#ifndef INCLUDE_H_EXECUTEACTIONSETTINGINFO
#define INCLUDE_H_EXECUTEACTIONSETTINGINFO

#include "tstring.hpp"

#include <atltime.h>

#include "ShowWindowType.hpp"
#include "ActionSettingParameter.hpp"

/*!
 * ANV֘Aݒ
 */
class ExecuteActionSettingInfo
{
public:

	/*!
	 * p[^Ƃɍ\z܂B
	 */
	ExecuteActionSettingInfo( const ActionSettingParameter& v_param );

	/*!
	 * Rs[RXgN^
	 * \param v_other Rs[
	 */
	ExecuteActionSettingInfo( const ExecuteActionSettingInfo& v_other );

	/*!
	 * Rs[
	 * \param v_other Rs[
	 */
	ExecuteActionSettingInfo& operator=( const ExecuteActionSettingInfo& v_other );

	/*!
	 * fXgN^
	 */
	~ExecuteActionSettingInfo();

	/*!
	 * ANV擾܂B
	 * \return ANV
	 */
	inline tstring getAction() const {
		return action_;
	}

	/*!
	 * ANVsvO擾܂B
	 * ϐWJ܂B
	 * \return vO
	 */
	inline tstring getAppName() const {
		return appName_;
	}

	/*!
	 * ANVsvOɈnp[^擾܂B
	 * ϐWJ܂B
	 * \return p[^
	 */
	inline tstring getParam() const {
		return param_;
	}

	/*!
	 * vZX̏I҂̗L擾܂B
	 * \return vZXI܂Ŏ̃vZXNȂꍇtrue
	 */
	inline unsigned int getMaxProcess() const {
		return nMaxProcess_;
	}

	/*!
	 * vZXNƂ̃EBhETCY
	 * \return EBhETCY
	 */
	inline ShowWindowType getShowWindow() const {
		return showWindow_;
	}

	/*!
	 * AvP[Vsp̃JgfBNgB
	 * ϐWJ܂B
	 * \return JgfBNg
	 */
	inline tstring getAppCurrentDir() const {
		return appCurrentDir_;
	}

	/*!
	 * p[^Lł邩肵܂B
	 * \return Lłtrue
	 */
	inline bool isAvailable() const {
		return ! action_.empty() && ! appName_.empty();
	}

	/*!
	 * ̃p[^擾܂B
	 */
	const ActionSettingParameter& getParameters() const
	{
		return parameter_;
	}

private:
	ActionSettingParameter parameter_;

	tstring action_;
	tstring appName_;
	tstring param_;
	ShowWindowType showWindow_;
	unsigned int nMaxProcess_;
	tstring appCurrentDir_;
};


#endif


